var bv = BrainVoyager;
var $ = bv.FindChild;

var o = new Object;
o.dialogFileName   = "COPE_v10.ui";
o.dialogAccessName = "PluginDialog";


// Called for the Browse buttons in the Estimate VDM tab.
function select_input(index) {
    bv.SetPluginStringParameter("task", "select_fmr_or_dmr");
    bv.ExecutePlugin();
    var filename = bv.GetPluginStringParameter("filename");
    if (filename) {
        var edit = $("filenameEdit"+index);
        var spinBox = $("volumeSpinBox"+index);
        edit.text = filename;
        spinBox.maximum = bv.GetPluginIntParameter("nr_of_volumes");
        spinBox.value = bv.GetPluginIntParameter("display_volume");
    }
}


o.initDlg = function() {
    var dlg = this.PluginDialog;

    // Estimate VDM tab
    $("browseButton0").clicked.connect(function() { select_input(0); });
    $("browseButton1").clicked.connect(function() { select_input(1); });
    $("estimateCloseButton").clicked.connect(this, this.close);
    $("estimateRunButton").clicked.connect(this, this.estimate);

    // Apply VDM tab
    $("vdmBrowseButton").clicked.connect(this, this.vdmBrowse);
    $("addButton").clicked.connect(this, this.add);
    $("checkButton").clicked.connect(this, this.check);
    $("applyCloseButton").clicked.connect(this, this.close);
    $("applyRunButton").clicked.connect(this, this.apply);

    bv.PrintToLog($("textBrowser").source);
    var sample_path = bv.PathToSampleData;
    var html_index = sample_path.replace("SampleData/", "Extensions/Plugins_64/CopePluginHelp/index.html");
    var html_index_file =  "file:///".concat(html_index);
    $("textBrowser").source = new QUrl(html_index_file);
    bv.PrintToLog($("textBrowser").source);
    
}


// Called for the Close buttons.
o.close = function() {
    this.PluginDialog.close();
}


// Called for the Run button on the Estimate VDM tab.
o.estimate = function() {
    // open FMR/DMR -- the C++ code needs an open FMR/DMR to create .map files
    var file0 = $("filenameEdit0").text;
    bv.OpenDocument(file0);

    // set parameters
    bv.SetPluginStringParameter("file0", file0);
    bv.SetPluginStringParameter("file1", $("filenameEdit1").text);
    bv.SetPluginIntParameter("volume0", $("volumeSpinBox0").value - 1);
    bv.SetPluginIntParameter("volume1", $("volumeSpinBox1").value - 1);
    bv.SetPluginIntParameter("rllr", $("estimateRllrRadioButton").checked);
    bv.SetPluginIntParameter("use_ic", $("seRadioButton").checked);
    bv.SetPluginIntParameter("use_ssd", $("ssdRadioButton").checked);
    bv.SetPluginIntParameter("apply_to_input", $("applyToInput").checked);
    //bv.SetPluginIntParameter("correct_motion", $("correctMotion").checked);
    bv.SetPluginIntParameter("save_derivative", $("saveDerivative").checked);
    bv.SetPluginIntParameter("fast_algorithm", $("linearAlgorithm").checked);

    // call C++ function
    bv.SetPluginStringParameter("task", "estimate");
    bv.ExecutePlugin();
}


o.vdmBrowse = function() {
    bv.SetPluginStringParameter("task", "select_vdm");
    bv.ExecutePlugin();
    var filename = bv.GetPluginStringParameter("filename");
    if (filename)
        $("vdmFilenameEdit").text = filename;
}


o.add = function() {
    bv.SetPluginStringParameter("task", "select_fmr_or_dmr");
    bv.ExecutePlugin();
    var filename = bv.GetPluginStringParameter("filename");
    if (filename)
        $("textEdit").append(filename);
}


o.check = function() {
    bv.SetPluginStringParameter("files", $("textEdit").plainText);
    bv.SetPluginStringParameter("task", "check");
    bv.ExecutePlugin();
}


o.apply = function() {
    files_string = $("textEdit").plainText;
    files = files_string.split("\n");
    if (files.length == 0)
        return;
    bv.OpenDocument(files[0]);

    bv.SetPluginIntParameter("rllr", $("applyRllrRadioButton").checked);
    bv.SetPluginStringParameter("vdm", $("vdmFilenameEdit").text);
    bv.SetPluginStringParameter("files", files_string);
    bv.SetPluginStringParameter("task", "apply");
    bv.ExecutePlugin();
}


o
